// Ecriture sur le module DIO701

#include <windows.h>
#include <canproto.h>

// dfinition des messages pour vxdcan
#define WM_CANPOST (WM_USER+1)
#define CANERROR	0xFFFFFFFF

typedef struct {
	unsigned char len;
	unsigned char arb[4];     
	unsigned char data[8] ;
	unsigned char rfu[2];    //not used
	unsigned char channel;    //not used 
        }CAN;
 CAN can_send,can_receive;


long CALLBACK WndProc (HWND hWnd, UINT message, UINT wParam, LONG lParam);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
						 PSTR szCmdLine, int iCmdShow)
{
	static char szAppNom[]="BusCAN";
	HWND hWnd;
	MSG Msg;
	WNDCLASS wndclass;

	if (!hPrevInstance)
	  {
	  wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
	  wndclass.lpfnWndProc   = (WNDPROC)WndProc;
	  wndclass.cbClsExtra    = 0 ;
	  wndclass.cbWndExtra    = 0 ;
	  wndclass.hInstance     = hInstance ;
	  wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
	  wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;
	  wndclass.lpszMenuName  = NULL ;
	  wndclass.lpszClassName = szAppNom ;
	  RegisterClass (&wndclass) ;
	  }
	  hWnd = CreateWindow (szAppNom,         // nom de la classe
			 "Ecriture DIO701",    // titre de la fenetre
			 WS_OVERLAPPEDWINDOW,     // style de la fenetre
			 CW_USEDEFAULT,           // position initiale en x
			 CW_USEDEFAULT,           // position initiale en y
			 CW_USEDEFAULT,           // largeur initiale
			 CW_USEDEFAULT,           // hauteur initiale
			 NULL,                    // handle de la fenetre mere
			 NULL,                    // handle du menu de la fenetre
			 hInstance,               // handle de l'instance
			 NULL) ;                  // parametres de creation
	  ShowWindow (hWnd, iCmdShow) ;
	  UpdateWindow (hWnd) ;
	  while (GetMessage (&Msg, NULL, 0, 0))
	  {
			TranslateMessage (&Msg) ;
			DispatchMessage (&Msg) ;
	  }
	  return Msg.wParam ;
	  }

long CALLBACK WndProc (HWND hWnd, UINT message, UINT wParam, LONG lParam)
	  {
	  // ventuellement dclaration de variables locales
		HDC         hdc ;
		PAINTSTRUCT ps ;
		RECT        rect ;
		static HANDLE NumFIFO;
		static HANDLE hCVxD;
		char szAffiche[80];
		char szTemp[10];
		int i;

		switch (message)
			{
				case WM_CREATE:	
				// Ouvrir le  driver ici
					hCVxD = CreateFile("\\\\.\\VXDCAN.VXD", 0,0,0,
                        CREATE_NEW, FILE_FLAG_DELETE_ON_CLOSE, 0);

					if (hCVxD == INVALID_HANDLE_VALUE )
					{
						MessageBox( hWnd, "Peut pas ouvrir VXDCAN.VXD !"," ", MB_OK );
						PostQuitMessage(0);
						return 0;
					}
					if (CAN_Open())
					{
					MessageBox( hWnd, "Peut pas ouvrir DEVICE DRIVER !"," ", MB_OK );
						PostQuitMessage(0);
						CloseHandle(hCVxD);
						return 0;
					}
				//enregistrer la fentre pour recevoir le message WM_CANPOST
					if ((NumFIFO=CAN_SetWMes(hWnd,WM_CANPOST ))==(HANDLE) CANERROR)
					{
 MessageBox( hWnd, "Peut pas enregistrer fentre!"," ", MB_OK| MB_SYSTEMMODAL);
						PostQuitMessage(0);
						CloseHandle(hCVxD);
						CAN_Close();
						return 0;
					}
				// initialisations diverses sur le bus
				// commande 0x141 : fixe les noeuds en mode polling
					can_send.len=2;
					can_send.arb[0]=0x03;
					can_send.arb[1]=0xE0;
					can_send.arb[2]=0;
					can_send.arb[3]=0;
					can_send.data[0]=0x01;
					can_send.data[1]=0x41;

					CAN_SendMessage((unsigned char *)&can_send);

				// commande 0x150 : dmarrage de la communication
					can_send.len=2;
					can_send.arb[0]=0x03;
					can_send.arb[1]=0xE0;
					can_send.arb[2]=0;
					can_send.arb[3]=0;
					can_send.data[0]=0x01;
					can_send.data[1]=0x50;

					CAN_SendMessage((unsigned char *)&can_send);

 		   				return 0;
		
				case WM_PAINT:	hdc = BeginPaint (hWnd, &ps) ;
						GetClientRect (hWnd, &rect) ;
			 DrawText (hdc, "Bouton droit : criture      Bouton gauche : lecture",
							 -1, &rect, DT_SINGLELINE | DT_CENTER | DT_VCENTER) ;
						EndPaint (hWnd, &ps) ;
						return 0 ;

				case WM_CANPOST:
					// un message a t reu, ce sont peut-tre les donnes
						CAN_GetMessage(NumFIFO,(unsigned char *)&can_receive);
					// et on extrait la donne utile et on l'affiche
						wsprintf(szAffiche,"Donne: ");
						for(i=0; i< can_receive.len; i++)
						{
							wsprintf(szTemp," %02X",can_receive.data[i]);
							strcat(szAffiche,szTemp);
						}
						MessageBox( hWnd, szAffiche," ", MB_OK );
						break;

				case WM_RBUTTONDOWN:	//ecrit donne
						can_send.len=1;
						can_send.arb[0]=0xA3;
						can_send.arb[1]=0xE0;
						can_send.arb[2]=0;
						can_send.arb[3]=0;
						can_send.data[0]=0x55;

						CAN_SendMessage((unsigned char *)&can_send);

						return 0;

				case WM_LBUTTONDOWN:	//demande de lecture donne
					can_send.len=2;
					can_send.arb[0]=0x23;
					can_send.arb[1]=0xE0;
					can_send.arb[2]=0;
					can_send.arb[3]=0;
					can_send.data[0]=0x01;
					can_send.data[1]=0x61;

					CAN_SendMessage((unsigned char *)&can_send);
				// et attendre de recevoir le message WM_CANPOST
					return 0;

				case WM_DESTROY: // on ferme tout et on s'en va
					CloseHandle(hCVxD);
					CAN_Close();
					PostQuitMessage (0) ;
					return 0 ;
			}
		return DefWindowProc (hWnd, message, wParam, lParam);
	  }
