// LecEcr.c  test de lecture/ecriture sur modules E/S TOR Gespac Bus CAN

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include "resource.h"

	// Fichier d'en-tete des fonctions de la lib
#include "CANproto.h"

	// Dfinition des messages pour vxdcan
#define WM_CANPOST (WM_USER+1)
#define CANERROR	0xFFFFFFFF

BOOL CALLBACK DialogProc (HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	// Identificateurs
		// de la file de message CAN
HANDLE NumFIFO;
		// du driver CAN
HANDLE hCVxD;

	// Dfinition de la structure pour construction de trame
typedef struct	{
					unsigned char len;
					unsigned char arb[4];
					unsigned char data[8] ;
					unsigned char rfu[2];	// inutilis
					unsigned char channel;	// inutilis
				}CAN;
 CAN can_send,can_receive;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
						 PSTR szCmdLine, int iCmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, DialogProc);
	return(0);
}


BOOL CALLBACK DialogProc (HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
   unsigned int val;
   char szAff[20];
   char szTemp[5];
   char szSais[5];
   int i;

	switch (uMsg)
   {
   case WM_INITDIALOG :		// Associer une icne avec la bote de dialogue.
						SendMessage(hwnd, WM_SETICON, TRUE,  (LPARAM) \
						LoadIcon(GetWindowInstance(hwnd), MAKEINTRESOURCE(IDI_ICON1)));
							// Initialiser la bote de dialogue en validant les contrles.
						EnableWindow(GetDlgItem(hwnd, IDD_DIALOG), TRUE);
							// Ouvrir le  driver VxD
						hCVxD = CreateFile("\\\\.\\VXDCAN.VXD",0,0,0,CREATE_NEW, FILE_FLAG_DELETE_ON_CLOSE, 0);

						if (hCVxD == INVALID_HANDLE_VALUE )
						{
							MessageBox( hwnd, "Peut pas ouvrir VXDCAN.VXD !"," ", MB_OK );
							PostQuitMessage(0);
							return 0;
						}
						if (CAN_Open())
						{
							MessageBox( hwnd, "Peut pas ouvrir DEVICE DRIVER !"," ", MB_OK );
							PostQuitMessage(0);
							CloseHandle(hCVxD);
							return 0;
						}
							//Enregistrer la fentre pour recevoir le message WM_CANPOST
						if ((NumFIFO=CAN_SetWMes(hwnd,WM_CANPOST ))==(HANDLE) CANERROR)
						{
							MessageBox( hwnd, "Peut pas enregistrer fentre!"," ", MB_OK);
							PostQuitMessage(0);
							CloseHandle(hCVxD);
							CAN_Close();
							return 0;
						}
							// initialisations diverses sur le bus
							// commande 0x141 : fixe tous les noeuds en mode polling
						can_send.len=2;
						can_send.arb[0]=0x03;
						can_send.arb[1]=0xE0;
						can_send.arb[2]=0;
						can_send.arb[3]=0;
						can_send.data[0]=0x01;
						can_send.data[1]=0x41;

						CAN_SendMessage((unsigned char *)&can_send);
							// ! FONDAMENTAL : laisser le temps aux modules de digrer la commande !
						Sleep(1);

							// commande 0x150 : dmarrage de la communication pour tous les noeuds
						can_send.len=2;
						can_send.arb[0]=0x03;
						can_send.arb[1]=0xE0;
						can_send.arb[2]=0;
						can_send.arb[3]=0;
						can_send.data[0]=0x01;
						can_send.data[1]=0x50;

						CAN_SendMessage((unsigned char *)&can_send);

							// ! FONDAMENTAL : laisser le temps aux modules de digrer la commande !
						Sleep(1);

						break;
   case WM_COMMAND : 	switch(LOWORD(wParam))
						{
							case IDCANCEL:	// On ferme tout et on s'en va
											CloseHandle(hCVxD);
											CAN_Close();
											EndDialog(hwnd, TRUE);
											return TRUE;
							case IDC_ECRIRE:	// Ecriture
												GetDlgItemText(hwnd, IDC_EDIT1, szSais, 4);
												val=atoi(szSais);
												can_send.len=1;
												can_send.arb[0]=0xA3;
												can_send.arb[1]=0xE0;
												can_send.arb[2]=0;
												can_send.arb[3]=0;
												can_send.data[0]=(unsigned char)val;
												CAN_SendMessage((unsigned char *)&can_send);
												return TRUE;
							case IDC_LIRE:	// Lecture
											// Demander la lecture
											can_send.len=2;
											can_send.arb[0]=0x23;	// interrogation d'un seul noeud
											can_send.arb[1]=0xE0;
											can_send.arb[2]=0;
											can_send.arb[3]=0;
											can_send.data[0]=0x01;
											can_send.data[1]=0x61;
											CAN_SendMessage((unsigned char *)&can_send);
												// et attendre de recevoir le message WM_CANPOST : Windows s'en charge ...
											return TRUE;
						}
   case WM_CANPOST:	// Un message a t reu, ce sont peut-tre les donnes
							// Lecture de la trame
						CAN_GetMessage(NumFIFO,(unsigned char *)&can_receive);
							// On extrait la donne utile et on affiche
						szAff[0]='\0';
						for(i=0; i< can_receive.len; i++)
						{
							wsprintf(szTemp,"%02X ",can_receive.data[i]);
							lstrcat(szAff,szTemp);
						}
						SetDlgItemText(hwnd,IDC_STATICTEXT,szAff);
						break;
   }
   return(FALSE);
}
