#include <windows.h>
#include "resource.h"
#include "CANproto.h"	//ventuellement modifier le chemin

//Dfinition des messages pour vxdcan
#define WM_CANPOST (WM_USER+1)
#define CANERROR 0xFFFFFFFF

//Dfinition de la structure pour construction de trame
typedef struct {
	unsigned char len;		//taille de la partie donne en octet
	unsigned char arb[4];	//champs d'harbitrage
	unsigned char data[8];	//octets de donnes
	unsigned char rfu[2];	//inutilis
	unsigned char channel;	//inutilis
				}CAN;

//Dclaration des variables pour mission et rception
CAN can_send;
CAN can_receive;

//Dclaration de la procdure (callback) de traitement des messages Windows
BOOL CALLBACK DialogProc (HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

//Point d'entre de l'application
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,PSTR szCmdLine,int iCmdShow)
{
	//
	//Mise en place de la structure graphique de l'application
	//
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),NULL,DialogProc);
	
	return(0);	

}

//Dfinition partielle de la procdure de traitement des messages Windows
BOOL CALLBACK DialogProc (HWND hwnd, UINT uMsg, WPARAM wParam,LPARAM lParam)
{
	//Dclaration de variables locales

	static HANDLE NumFIFO;
	static HANDLE hCVxD;
	char szAffiche[80];
	char table[20];
	int i;



//	HANDLE fifo;

	switch (uMsg)
	{
	case WM_INITDIALOG :

		
		//Ouvrir le dossier driver VxD
		hCVxD = CreateFile("\\\\.\\VXDCAN.VXD", 0,0,0, CREATE_NEW, FILE_FLAG_DELETE_ON_CLOSE, 0);

		if (hCVxD == INVALID_HANDLE_VALUE)
		{
			MessageBox(hwnd,"Erreur d'ouverture du dossier driver VxD","Erreur",MB_OK);
			//affichage d'un message d'erreur
		}
		
		//Ouvrir le bus
		if (CAN_Open())
		{
			MessageBox(hwnd,"Erreur d'ouverture du bus","Erreur",MB_OK);
			//affichage d'un message d'erreur
		
		}
			//Enregistrer la fentre pour recevoir le message WM_CANPOST
		if ((NumFIFO=CAN_SetWMes(hwnd,WM_CANPOST ))==(HANDLE) CANERROR)
		{
			MessageBox(hwnd, "Peut pas enregistrer fentre!"," ", MB_OK);
			PostQuitMessage(0);
			CloseHandle(hCVxD);
			CAN_Close();
			break;
		}
				MessageBox(hwnd,"Initialisation...","Message",MB_OK);

			//stoppe toutes communications
			//commande 0x151
			can_send.len=2;		//taille 
			can_send.arb[0]=3;
			can_send.arb[1]=0xE0;
			can_send.data[0]=1;
			can_send.data[1]=0x51;
			//envoie d'un message
			CAN_SendMessage((unsigned char *)&can_send);

			Sleep(1);


			//fixe tous les noeuds en mode polling
			//commande 0x141
			can_send.len=2;
			can_send.arb[0]=3;
			can_send.arb[1]=0xE0;
			can_send.data[0]=1;
			can_send.data[1]=0x41;
			//envoie d'un message
			CAN_SendMessage((unsigned char *)&can_send);

			Sleep(1);

			//dmarrage de la communication pour tous les noeuds
			//commande 0x150
			can_send.len=2;
			can_send.arb[0]=3;
			can_send.arb[1]=0xE0;
			can_send.data[0]=1;
			can_send.data[1]=0x50;
			CAN_SendMessage((unsigned char *)&can_send);
			Sleep(1);
			
			break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		
		case IDC_allumer:
			GetDlgItemText(hwnd,IDC_donnee,table,sizeof(table));
			

			i=atoi(table);
			
			can_send.len=1;
			can_send.arb[0]=0xA3;
			can_send.arb[1]=0xE0;
			can_send.data[0]=i;
			CAN_SendMessage((unsigned char *)&can_send);
			Sleep(1);
			return TRUE;
		
		case IDC_eteindre:
			can_send.len=1;
			can_send.arb[0]=0xA3;
			can_send.arb[1]=0xE0;
			can_send.data[0]=0x00;
			CAN_SendMessage((unsigned char *)&can_send);
			Sleep(1);
			return TRUE;

		case IDC_acquerir:
			can_send.len=2;
			can_send.arb[0]=0x23;
			can_send.arb[1]=0xE0;
			can_send.data[0]=1;
			can_send.data[1]=0x61;
			CAN_SendMessage((unsigned char *)&can_send);
			Sleep(1);
			return TRUE;


		case IDC_Quitter:
			CAN_Close();
			CloseHandle(hCVxD);
			
			EndDialog(hwnd,TRUE);
			return TRUE;
		}
		break;
		
	case WM_CANPOST:
		//	MessageBox(hwnd,"Vous avez un Message","Message",MB_OK);
		CAN_GetMessage(NumFIFO,(unsigned char *)&can_receive);
		
		SetDlgItemInt(hwnd,IDC_donnee,can_receive.data[0],0);


		MessageBox(hwnd,can_receive.data[0],"Message",MB_OK);
	
		break;

	case WM_DESTROY: //On ferme tout et on s'en va
		CloseHandle(hCVxD);
		CAN_Close();
		PostQuitMessage (0);
		break;
	}

	//
	//Eventuellement autre code en fonction du cahier des charges de l'application
	//
	return FALSE;
}
