//****include et define

	#include <windows.h>
	#include <string.h>
	#include <stdio.h>
	#include "resource.h"
	#include "CANproto.h"	//ventuellement modifier le chemin

//Dfinition des messages pour vxdcan
#define WM_CANPOST (WM_USER+1)
#define CANERROR 0xFFFFFFFF
//**********************

//*****structure CAN
//Dfinition de la structure pour construction de trame
typedef struct {
	unsigned char len;		//taille de la partie donne en octet
	unsigned char arb[4];	//champs d'harbitrage
	unsigned char data[8];	//octets de donnes
	unsigned char rfu[2];	//inutilis
	unsigned char channel;	//inutilis
				}CAN;
//***********************


//****Fonctions

	//fonction d'envoi d'info sur le can
	int Tcan(unsigned char,unsigned char,unsigned char,unsigned char,unsigned char,
			unsigned char,unsigned char,unsigned char,unsigned char,unsigned char,
			unsigned char,unsigned char,unsigned char);

	//Dclaration des variables pour mission et rception
	CAN can_send;
	CAN can_receive;

	//Dclaration de la procdure (callback) de traitement des messages Windows
	BOOL CALLBACK DialogProc (HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	

//************************


//******Point d'entre de l'application
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,PSTR szCmdLine,int iCmdShow)
{
	//
	//Mise en place de la structure graphique de l'application
	//
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),NULL,DialogProc);
	
	return(0);	

}

//*******************************************

//Dfinition partielle de la procdure de traitement des messages Windows
BOOL CALLBACK DialogProc (HWND hwnd, UINT uMsg, WPARAM wParam,LPARAM lParam)
{



//******variables locales

	static HANDLE NumFIFO;
	static HANDLE hCVxD;
	char chaine[40];
	double res;
	char cons[30];
	double consigne;
//**********************



	switch (uMsg)
	{
	case WM_INITDIALOG :

	
//*****ouverture du Bus CAN

		//Ouvrir le dossier driver VxD
		hCVxD = CreateFile("\\\\.\\VXDCAN.VXD", 0,0,0, CREATE_NEW, FILE_FLAG_DELETE_ON_CLOSE, 0);

		if (hCVxD == INVALID_HANDLE_VALUE)
		{
			MessageBox(hwnd,"Erreur d'ouverture du dossier driver VxD","Erreur",MB_OK);
			//affichage d'un message d'erreur
		}
		
		//Ouvrir le bus
		if (CAN_Open())
		{
			MessageBox(hwnd,"Erreur d'ouverture du bus","Erreur",MB_OK);
			//affichage d'un message d'erreur
		
		}
			//Enregistrer la fentre pour recevoir le message WM_CANPOST
		if ((NumFIFO=CAN_SetWMes(hwnd,WM_CANPOST ))==(HANDLE) CANERROR)
		{
			MessageBox(hwnd, "Peut pas enregistrer fentre!"," ", MB_OK);
			PostQuitMessage(0);
			CloseHandle(hCVxD);
			CAN_Close();
			break;
		}
				MessageBox(hwnd,"Initialisation...","Message",MB_OK);
//***************************************


//****initialisation
			//stoppe toutes communications
			//commande 0x141
				Tcan(2,3,0xE0,0,0,1,0x41,0,0,0,0,0,0);

			//fixe tous les noeuds en mode polling
			//commande 0x150
				Tcan(2,3,0xE0,0,0,1,0x50,0,0,0,0,0,0);
			
			//initialisation des sortie TOR 
			//commande 0x08
				Tcan(1,0xA3,0xE0,0,0,0x08,0,0,0,0,0,0,0);

			break;
//*************************

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		

//****lancement de la regulation
		case IDC_regulation:
			do{

				//interrogation des entre analogique
				Tcan(2,0x25,0xE0,0,0,1,0x61,0,0,0,0,0,0);
				
				Sleep(1000);
			}while(LOWORD(wParam)==IDC_quitter);
			
			return TRUE;

//******************************
			

//****sortie du programme
		
case IDC_quitter:
			
				//fermeture du can
				CAN_Close();

				CloseHandle(hCVxD);
				
				EndDialog(hwnd,TRUE);

				return TRUE;
		}
		break;
//****************************		



//****recuperation de la valeur du can suite  une trame d'interrogation

		case WM_CANPOST:

	
	//*******rcuperation de la temprature de consigne
				GetDlgItemText(hwnd,IDC_consigne,cons,sizeof(cons));

				consigne=atof(cons);
				
	//******recuperation de la temprature courante

		//recuperation de la trame
				CAN_GetMessage(NumFIFO,(unsigned char *)&can_receive);

		//tranformation de la trame en volt
				res=can_receive.data[1]*256+can_receive.data[0];
				res*=(10.0/4096);
			//transformation des volts en temperature
					res*=10.0;

	//*******affichage de la temprature courante
		//conversion en texte pour l'affichage
				sprintf(chaine,"%lf",res);
		//affichage
				SetDlgItemText(hwnd,IDC_courante,chaine);

	//******regulation en fonction de la temprature courante
			//*****si Tcourante<Tconsigne on chauffe
				if(res<consigne) Tcan(8,0xA7,0xE0,0,0,0xFF,0x0F,0x00,0x08,0x00,0x08,0x00,0x08);
			//*****sinon on arrete de chauffer
				else Tcan(8,0xA7,0xE0,0,0,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08);

	
		break;
//**********************************************************


//****fermeture	
	case WM_DESTROY: //On ferme tout et on s'en va
		CloseHandle(hCVxD);
		CAN_Close();
		PostQuitMessage (0);
		break;
	}


	//Eventuellement autre code en fonction du cahier des charges de l'application
	return FALSE;
}
//*********************



//********fonction d'envoi d'ordre sur le can
int Tcan(unsigned char len,
		 unsigned char arb0,	
		 unsigned char arb1,
		 unsigned char arb2,
		 unsigned char arb3,
		unsigned char data0,
		unsigned char data1,
		unsigned char data2,
		unsigned char data3,
		unsigned char data4,
		unsigned char data5,
		unsigned char data6,
		unsigned char data7
		)
{
				can_send.len=len;
				can_send.arb[0]=arb0;
				can_send.arb[1]=arb1;
				can_send.arb[2]=arb2;
				can_send.arb[3]=arb3;
				can_send.data[0]=data0;
				can_send.data[1]=data1;
				can_send.data[2]=data2;
				can_send.data[3]=data3;
				can_send.data[4]=data4;
				can_send.data[5]=data5;
				can_send.data[6]=data6;
				can_send.data[7]=data7;

				CAN_SendMessage((unsigned char *)&can_send);

				Sleep(1);
				return 0;
}

//***************************************